var Dfe43000_ParametrosPorFornecedor_Controller = function(ScreenService, MessageService, templateManager, General, ZHPromise, ZhFilterPreferences) {
    
    var ignoredKeys = ["__rightActions", "__leftActions", "_children", "_parent", "__groupHeaders", "__index", "__isSelected", "__notSelectable", "$$hashKey"];
    
    var hasDuplicateKeys = function(widget) {
        var codFornecedor = widget.currentRow.CDFORNECED;
        var arr = widget.dataSource.data.filter(function(data) {
            return (data.CDFORNECED === codFornecedor);
        });
        return (arr.length > 1);
    };
    
    this.saveParametrizacao = function(widget) {
        if (widget.isValid()) {
            if (!hasDuplicateKeys(widget)) {
                General.saveCrud(widget);
                MessageService.showMessageByCode("REGISTRO_SALVO");
            }
        }
    };

    this.validateParametersExistance = function(widget) {
        if ((widget.dataSource.data.length === 0) && (widget.dataSourceFilter.length > 0)) {
            widget.newRow();
            General.justInteger('#NRDIASBLOQNFFOR');
            popupWidget = widget.container.getWidget("filterPopup");
            widget.currentRow.CDFORNECED = popupWidget.currentRow.CDFORNECED;
            widget.currentRow.NMRAZSOCFORN = popupWidget.currentRow.NMRAZSOCFORN;
        }
    };

    this.onChangeBloqAlt = function(field) {
        if(field.value() == 'S') {
            field.widget.getField('DSEMAILITPEN').readOnly = false;
        }
        else {
            field.widget.currentRow.DSEMAILITPEN = '';
            field.widget.getField('DSEMAILITPEN').readOnly = true;
        }
        field.reload();
    };
    
    this.edit = function(widget) {
        if(widget.currentRow.IDBLOQALTPRODREL == 'S') {
            widget.getField('DSEMAILITPEN').readOnly = false;
        }
        else {
            widget.getField('DSEMAILITPEN').readOnly = true;
        }
        General.edit(widget);
    };

    this.openPopupCadastroAutomatico = function(args){
        var widget = args.owner.widget;
        var widgetPopup = templateManager.container.getWidget('CADASTROAUTOMATICOPARAMFORN');
        widgetPopup.isVisible = true;
        widgetPopup.activate();
        widgetPopup.edit();
        ScreenService.openPopup(widgetPopup);
    };
    
    this.saveCadastroAutomatico = function(widget){
        ignoredKeys.push("changed", "$error","NMRAZSOCFORN", "NRINSJURFORN");
        if(widget.isValid()) {
            var row = Util.clone(widget.currentRow, ignoredKeys);
            if(row.CDFORNECED.length >= 1000){
                var fornecedores = [];
                while(row.CDFORNECED.length >= 1000){
                    fornecedores.push(row.CDFORNECED.splice(-1000));
                }
                fornecedores.push(row.CDFORNECED);
                
                //Executa um apos o outro
                let chain = ZHPromise.when();
                fornecedores.forEach(fornecedor => {
                    const cadastraFornecedores = fornecedor =>  {
                        row.CDFORNECED = fornecedor;
                        return General.callRestEngine('df_entrada#/cadastroAutomaticoParamForn', 'Row', row);
                    };
                    chain = chain.then(() => cadastraFornecedores(fornecedor));
                });
                
                chain.then(() => {
                    var widgetActivate = templateManager.container.getWidget('parametrosFornecedor');
                    var widgetPopup = templateManager.container.getWidget('CADASTROAUTOMATICOPARAMFORN');
                    
                    widgetPopup.isVisible = false;
                    widgetPopup.currentRow = {};
                    ScreenService.closePopup(widgetPopup);
                    ScreenService.showMessage('Operação realizada com sucesso');
                    widgetActivate.activate();
                    widgetActivate.reload();
                });
    
            }else {
               General.callRestEngine('df_entrada#/cadastroAutomaticoParamForn', 'Row', row).then(function(success){
                    var widgetActivate = templateManager.container.getWidget('parametrosFornecedor');
                    var widgetPopup = templateManager.container.getWidget('CADASTROAUTOMATICOPARAMFORN');
                    
                    widgetPopup.isVisible = false;
                    widgetPopup.currentRow = {};
                    ScreenService.closePopup(widgetPopup);
                    ScreenService.showMessage('Operação realizada com sucesso');
                    widgetActivate.activate();
                    widgetActivate.reload();
    
                },
                function(callback){
                        if(callback.data){
                            ScreenService.showMessage(callback.data.error);
                        }
                    }
                ); 
            }
        }
    };
    
    this.cancelCadastroAutomatico = function() {
        var widget = templateManager.container.getWidget('CADASTROAUTOMATICOPARAMFORN');
        widget.currentRow = {};
        widget.isVisible = false;
        var widgetActivate = templateManager.container.getWidget('parametrosFornecedor');
        ScreenService.closePopup(widget);
        widgetActivate.activate();
        widgetActivate.reload();
    };
    
    this.openFilter = function(widget) {
        ZhFilterPreferences.openFilterWidget(widget, true).then(response => {
            var filter = templateManager.container.getActiveWidget();
            var clearFilter = filter.actions.filter(action => action.name === 'clear')[0];
            clearFilter.shortcutKey = 'ctrl+backspace';
            clearFilter.tooltip = 'Limpar Filtro (CTRL + Backspace)';
            filter.reload();
        
        });
    };
    
};

Configuration(function(ContextRegister) {
    ContextRegister.register("Dfe43000_ParametrosPorFornecedor_Controller", Dfe43000_ParametrosPorFornecedor_Controller);
});